// Center of masses ; UVa 10002
// Triangulation du polygone pour calculer le centre de gravit

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define EPSILON 1e-8

struct point
{
  double x, y;
};

point polygone[100]; // pour stocker les points du polygone
point bas_gauche; // le point le plus en bas  gauche

bool nul(double x)
{
  return (fabs(x) < EPSILON);
}

int signe(double x)
{
  if (x >= EPSILON)
    return 1;
  if (nul(x))
    return 0;
  return -1;
}

double distance(point p, point q)
{
  double x = p.x-q.x;
  double y = p.y-q.y;
  return sqrt(x*x+y*y);
}

// Pour qsort
int comparaison(const void *p1, const void *p2)
{
  double ax = ((point *) p1)->x - bas_gauche.x;
  double ay = ((point *) p1)->y - bas_gauche.y;
  double bx = ((point *) p2)->x - bas_gauche.x;
  double by = ((point *) p2)->y - bas_gauche.y;
  if (nul(ax) && nul(ay))
    {
      if (nul(bx) && nul(by))
	return 0;
      return -1;
    }
  if (nul(bx) && nul(by))
    return 1;
  if (nul(ay*bx - by*ax))
    return (signe(distance(*((point *) p2), bas_gauche) -
		  distance(*((point *) p1), bas_gauche)));
  return signe(ay*bx - by*ax);
}

// Aire du triangle (0,i,i+1)
double aire(int i)
{
  return (polygone[0].x*polygone[i].y
	  - polygone[0].y*polygone[i].x
	  + polygone[0].y*polygone[i+1].x - polygone[0].x*polygone[i+1].y
	  + polygone[i].x*polygone[i+1].y-polygone[i].y*polygone[i+1].x)/2;
}

// Abscisse du centre de gravit du triangle (0,i,i+1)
double centre_x(int i)
{
  return (polygone[0].x+polygone[i].x+polygone[i+1].x)/3;
}

// Ordonne du centre de gravit du triangle (0,i,i+1)
double centre_y(int i)
{
  return (polygone[0].y+polygone[i].y+polygone[i+1].y)/3;
}

int main()
{
  double aire_en_cours, aire_triangle;
  point centre_en_cours;

  int n; // nombre de points du polygone

  std::cin >> n;

  while (n > 2)
    {
      // lecture de l'entre
      for (int i=0; i<n; ++i)
	std::cin >> polygone[i].x >> polygone[i].y;

      // tri pour obtenir les points dans l'ordre
      bas_gauche.x = polygone[0].x;
      bas_gauche.y = polygone[0].y;
      for (int i=1; i<n; ++i)
	{
	  if (polygone[i].x <= bas_gauche.x - EPSILON)
	    {
	      bas_gauche.x = polygone[i].x;
	      bas_gauche.y = polygone[i].y;
	    }
	  if (nul(polygone[i].x-bas_gauche.x) &&
	      (polygone[i].y < bas_gauche.y - EPSILON))
	    bas_gauche.y = polygone[i].y;
	}
      qsort(polygone, n, sizeof(point), comparaison);

      aire_en_cours = 0;
      centre_en_cours.x = 0;
      centre_en_cours.y = 0;

      for (int i=1; i<n-1; ++i)
	{
	  aire_triangle = aire(i);
	  centre_en_cours.x += centre_x(i)*aire_triangle;
	  centre_en_cours.y += centre_y(i)*aire_triangle;
	  aire_en_cours += aire_triangle;
	}
      double cx = .00001+(centre_en_cours.x) / aire_en_cours;
      double cy = .00001+(centre_en_cours.y) / aire_en_cours;

      printf("%.3f %.3f\n", cx, cy);

      std::cin >> n;
    }
}
