// Cutting a polygon ; UVa 10867

#include <iostream>
#include <stdio.h>
#include <math.h>

#define DOUBLE_MAX 10e38
#define EPSILON 1e-8

struct point
{
  double x, y;
};

struct droite
{
  double a, b, c;
};

point polygone[1000]; // stocker le polygone
droite cotes[1000]; // stocker les quations des cts
int n; // nombre de sommets du polygone en cours

// A peu prs gal
bool egal(double x, double y)
{
  if (fabs(x-y) <= EPSILON)
    return true;
  return false;
}

// A peu prs gal pour des points
bool egal_point(point *p, point *q)
{
  return (egal(p->x, q->x) && egal(p->y, q->y));
}

// Equation de la droite passant par p et q
void equation(point *p, point *q, droite *d)
{
  // droite verticale
  if (egal(p->x, q->x))
    {d->b = 0; d->a = 1; d->c = - p->x;}
  // cas gnral
  else
    {
      d->b = -1;
      d->a = (q->y - p->y)/(q->x - p->x);
      d->c = p->y - d->a * p->x;
    }
}

// Calcul de l'intersection de deux droites
// valeur de retour 0=position gnrale, 1=parallles distinctes, 2=confondues
int intersection(droite *d, droite *e, point *p)
{

  // si d est horizontale
  if (egal(d->a, 0))
    {
      // si e aussi
      if (egal(e->a, 0))
	{
	  // si elles sont confondues
	  if (egal(d->c * e->b, d->b * e->c))
	    return 2;
	  return 1;
	}
      p->y = - d->c / d->b;
      p->x = (d->c * e->b / d->b - e->c) / e->a;
      return 0;
    }

  // cas gnral (d->a non nul)
  if (egal(e->b, e->a / d->a * d->b))
    {
      if (egal(e->c, e->a / d->a * d->c))
	return 2;
      return 1;
    }
  p->y = (e->a / d->a * d->c - e->c)/(e->b - e->a / d->a * d->b);
  p->x = -(d->b * p->y + d->c) / d->a;
  return 0;
}

double MIN(double x, double y)
{
  if (x<y)
    return x;
  return y;
}

double MAX(double x, double y)
{
  if (x>y)
    return x;
  return y;
}

// Le point p est-il (au sens large) dans le rectangle dfini par s1 et s2 ?
bool point_dans_boite(point *p, point *s1, point *s2)
{
  return ((MIN(s1->x, s2->x) < p->x + EPSILON)
	  && (MAX(s1->x, s2->x) > p->x - EPSILON))
    && ((MIN(s1->y, s2->y) < p->y + EPSILON)
	&& (MAX(s1->y, s2->y) > p->y - EPSILON));
}

int signe(double x)
{
  if (egal(x, 0))
    return 0;
  if (x < -EPSILON)
    return -1;
  return 1;
}

// Comparaison (ordre lexicographique)
int comparaison(point *p, point *q)
{
  double x = p->x - q-> x;
  double y = p->y - q-> y;
  if (egal(x, 0))
    return signe(y);
  return signe(x);
}

// intersection de la droite d et du segment [polygone[i], polygone[i+1]]
// stocke l'intersection dans p
// interseg retourne 0 s'il existe un unique point d'intersection,
// 1 si aucun point d'intersection,
// 2 si la droite et le segment sont confondus. Dans ce dernier cas, la plus
// petite extrmit du segment est retourne.
int interseg(droite *d, int i, point *p)
{
  int inter = intersection(d, &cotes[i], p);
  // si les droites sont parallles distinctes
  if (inter == 1)
    return 1;
  // si elles s'intersectent en un point
  if (inter == 0)
    if (point_dans_boite(p, &polygone[i], &polygone[(i+1)%n]))
      return 0;
    else
      return 1;
  // sinon elles sont confondues
  if (comparaison(&polygone[i], &polygone[(i+1)%n]) < 0)
    {
      p->x = polygone[i].x;
      p->y = polygone[i].y;
    }
  else
    {
      p->x = polygone[(i+1)%n].x;
      p->y = polygone[(i+1)%n].y;
    }
  return 2;
}

// Distance entre deux points
double distance(point *p, point *q)
{
  double x = p->x - q->x;
  double y = p->y - q->y;
  return sqrt(x*x+y*y);
}

int main()
{
  int m; // nombre de droites
  point p, q; // les deux points dfinissant la droite
  point amin, a; // pour la recherche des points d'intersection
  bool interieur; // pour le calcul de la longueur
  droite d, dprime; // droite en cours et une droite parallle proche
  double longueur;

  bool trouve, estconfondu, estsommet;
  int coteconfondu, sommettrouve;

  int type_inter[1000]; // type d'intersection des cts avec la droite d
  point inters[1000]; // point d'intersection des cts avec la droite d
  int type_interprime[1000]; // type d'intersection des cts avec dprime
  point intersprime[1000]; // point d'intersection des cts avec dprime

  std::cin >> n >> m;

  while ((n != 0) || (m != 0))
    {
      // lecture du polygone
      for (int i=0; i<n; ++i)
	std::cin >> polygone[i].x >> polygone[i].y;
      // calcul des cts

      for (int i=0; i<n; ++i)
	equation(&polygone[i], &polygone[(i+1)%n], &cotes[i]);

      // pour chaque droite
      for (int i=0; i<m; ++i)
	{
	  std::cin >> p.x >> p.y >> q.x >> q.y;
	  equation(&p, &q, &d);

	  // droite parallle trs proche
	  dprime.a = d.a; dprime.b = d.b;
	  dprime.c = d.c + 10*EPSILON*(d.b==0?d.a:d.b);

	  // mise  jour de type_inter, etc.
	  for (int j=0; j<n; ++j)
	    {
	      type_inter[j] = interseg(&d, j, &inters[j]);
	      type_interprime[j] = interseg(&dprime, j, &intersprime[j]);
	    }

	  interieur = false;
	  amin.x = -DOUBLE_MAX;
	  amin.y = -DOUBLE_MAX;

	  longueur = 0;

	  while (1)
	    {
	      a.x = DOUBLE_MAX;
	      a.y = DOUBLE_MAX;
	      trouve = false;
	      // recherche du plus petit point d'intersection a > amin
	      for (int j=0; j<n; ++j)
		{
		  if ((type_inter[j] != 1) &&
		      (comparaison(&inters[j], &a) < 0) &&
		      (comparaison(&inters[j], &amin) > 0))
		    {
		      trouve = true;
		      a.x = inters[j].x;
		      a.y = inters[j].y;
		      if (type_inter[j] == 2)
			{
			  estconfondu = true;
			  coteconfondu = j;
			}
		      else
			if (type_inter[(j+1)%n] == 2)
 			  {
 			    estconfondu = true;
 			    coteconfondu = (j+1)%n;
			  }
			else
			  if (type_inter[(j+n-1)%n] == 2)
			    {
			      estconfondu = true;
			      coteconfondu = (j+n-1)%n;
			    }
			  else
			    estconfondu = false;

		      if (egal_point(&a, &polygone[(j+1)%n]))
			{
			  estsommet = true;
			  sommettrouve = (j+1)%n;
			}
		      else
			if (egal_point(&a, &polygone[j]))
			  {
			    estsommet = true;
			    sommettrouve = j;
			  }
			else
			  estsommet = false;
		    }
		}
	      // si on n'a pas trouve de point, on sort de la boucle
	      if (!trouve)
		break;

	      // calcul de la longueur
	      if (interieur)
		longueur += distance(&a, &amin);
	      if (estsommet)
		{
		  if (estconfondu)
		    {
		      amin.x = a.x;
		      amin.y = a.y;
		      if (coteconfondu == sommettrouve)
			{
			  a.x = polygone[(coteconfondu+1)%n].x;
			  a.y = polygone[(coteconfondu+1)%n].y;
			}
		      else
			{
			  a.x = polygone[coteconfondu].x;
			  a.y = polygone[coteconfondu].y;
			}
		      longueur += distance(&a, &amin);
		      if ((type_interprime[(coteconfondu+n-1)%n] != 1) xor
			  (type_interprime[(coteconfondu+1)%n] != 1))
			interieur = !interieur;
		    }
		  else
		    {
		      if ((type_interprime[(sommettrouve+n-1)%n] != 1) xor
			  (type_interprime[sommettrouve] != 1))
			interieur = !interieur;
		    }
		}
	      else
		interieur = !interieur;
	      amin.x = a.x;
	      amin.y = a.y;
	    }
	  printf("%.3f\n", longueur);
	}
      std::cin >> n >> m;
    }
}
